#	2.24 92/01/28
#	This file controls psroff, you can insert additional printer
#	types here.  These are eval'd *late* in processing, so that
#	you can insert $copies etc.
#
#	This file contains a couple lines that specify the parameters
#	for each different -T<xx> option to psroff.  The -T<xx> options
#	for psroff select which psroff configuration/printer method you
#	wish to use.  Most people won't have to change anything except
#	"trofftype" and lparg.  The former once, the latter for each -T
#	option that is applicable to you.  Each entry is commented
#	with an english description of the configuration.  Find the one[s]
#	closest to what you want, and modify as necessary.
#
#	Syntax:
#
# troff=<path to troff>
# trofftype=[-F...|-T...]
# name width=<width> t2arg=<troff2ps args> lparg=<lp command line> ptr=<ptr>
#		<repeat as many printers that you have>
#
#	"troff" and "trofftype" stay in effect for each subsequent
#	printer definition until explicitly overridden:
#
#	if troff omitted or assigned "", will use your PATH for troff.
#	if trofftype omitted or assigned "", will not use width table
#		directories, and "width" will be unused.  This is not
#		recommended if you have printers with different character
#		widths.  Psroff will complain.  See trofftype assignment below.
#
#	name: name of config (eg: xt for ditroff->xtroff).  The name
#		is used by psroff to select the configuration via -T<name>.
#	width: name of width files (eg: "ps" for %%FONTDIR%%/ps/ftXX).
@		This is what troff is told, not necessarily troff2ps.
#	ptr: default physical printer name (eg: "lp -d$ptr")
#
#	Useful troff2ps args:
#		-T<type>	driver type (ps, lj, lj3, dt)
#		-p<printer>	printer-specific initializations - eg:
#				prefix for *.lib and *.fonts files.
#				(defaults to <type>).  Should be set
#				*after* -T.
#		-d<device>	x T <device> for ditroff drivers.
#				(defaults to alw)  Normally is same
#				as width parameter.  Only matters if you're
#				driving some other ditroff drivers.
#		-R<num>		ditroff resolution to use.  Default 300
#		-O<pageoffset>	offset to be applied *bypassing* troff.
#				Default "-O.5i".  Set to 0 to get this
#				perfectly offset-compatible with other
#				troffs.  Most macro packages are set to
#				centre their default page layout in
#				(effectively) 7.5i, the adapters plus
#				the .5i default makes pages centre
#				by default in 8.5i (matter of taste).
#		-Y<vertoff>	ditto, but vertical.  Default 0.
#				Some postscript printers differ in location.
#		-N		The troff is actually ditroff.  (You have to
#				have ditroff widths installed for this!)
#		-G<sizescale>	If you're driving with groff, and the sizescale
#				parameter is specified in the DESC file, you
#				have to supply the sizescale parameter here.
#		-Z		optimizer
#		-S		Use "stop" to terminate Postscript instead
#				of control-D
#		-W<directory>	location of CAT width tables.  Defaults
#				to FONTDIR/<type>/ft*
#
#	lparg: how to get output to printer.  Note the "-n$copies" and
#		-d$ptr.  The $ptr is the psroff selected physical printer
#		id, and is what would be specified by psroff -d<printer>.
#		Default "ptr" is described above.  psxlate is for
#		page-flipping postscript.  psxlate should really be in
#		your print spooler.  Or, you could do the psxlate and
#		print spool invocation manually simply by changing lparg
#		to "cat".
#
#		On BSDish systems (eg: SunOS, Ultrix etc.) that have lpr
#		you want:
#			lparg='lpr -#$copies -P$ptr'
#		On System V systems with "lp" you want:
#			lparg='lp -n$copies -d$ptr'
#
#		Warning: HP Laserjet output needs a 8-bit path without
#		any newline or tab expansion.  You will have to examine
#		your print spooler interface script or documentation to
#		see how to invoke it.  On many System V systems it's "-og"
#		(graphics) which leads to a lparg setting of:
#			lparg='lp -og -n$copies -d$ptr'
#
#		Some systems have environment variables that can be
#		used to default the printer in lp[r].  Your best bet is to
#		simply leave the "-?$ptr" option out.  However, you
#		should be cautious about this - a single environment
#		variable won't be sufficient when you're using multiple
#		psroff -T's.  For example, if you have a Laserjet and
#		Postscript printer, the environment variable would
#		have to change for -Tlj versus -Tps.  Often it's
#		the same physical printer but different logical names.
#
#	One further option: if you add "v=1" to the entry, catconv will
#	be invoked.  This will enable the ditroff emulation facilities
#	so that \X'...' (eg: psfig), \D'...' (drawing commands), and the
#	extended character set will be enabled.  You MUST have perl to have
#	this work.  This isn't needed for ditroff.
#	
#	Use single quotes for all strings that have embedded blanks or
#	other metacharacters.  (This delays the variable replacement until
#	the correct point).  Lines can be continued by prepending the
#	continuation lines with the "name" followed by whitespace.
#
#	psroff will use the last assignments to troff and trofftype
#	prior to the matching name.
#
#	Note: for the automatic ditroff width table installer to work,
#	the width parameter, -N and -W (if present) options must be
#	on the same line.

troff=''
trofftype='-T$width'
#	Uncomment the following if you're a Sun or Ultrix -F troff.
#	Check your manual pages.  (Though some support -F without mentioning
#	it in their manual pages).  The default is "-T" (Xenix and a few others)
#	Most BSD-derived troffs use -F, including those needing ASCIIWIDTHS
#	turned on.
#trofftype='-F%%FONTDIR%%/$width/ftXX'

#	psroff generating postscript directly from CAT troff.
#	The clause "| $LIBDIR/psxlate -r" is there to reverse the pages
#	for some Postscript printers (eg: the ones that print the first
#	page face up and then drop the second page face up on top of the
#	first), most more recent Postscript printers don't need this so
#	you can remove the psxlate call alltogether.  Actually, even if
#	you do need to reverse pages for your printer, psxlate should
#	REALLY be in your spooler rather than here - see MISC for more
#	details.  Or, you could do psxlate and the print spooler manually.
#	In that case simply change lparg to be lparg='cat'.
#
ps	width=ps t2arg='-Tps -Z -W%%FONTDIR%%/ps'
ps	lparg='| $LIBDIR/psxlate -r | rlp -d$ptr -n$copies'
ps	ptr='gate!AppleLaser'

#	For testing new width tables without clobbering real one.
tps	width=tps t2arg='-Tps -Z -W%%FONTDIR%%/tps'
tps	lparg='| $LIBDIR/psxlate -r | rlp -d$ptr -n$copies' ptr='gate!AppleLaser'

#	System V'ish LJ printing to printer called laser.
#	Don't use this for Laserjet III's - see the *lj3* entries below.
#	(Your lp filter script should support -og (8 bit, no filtering))

lj	width=lj t2arg=-Tlj lparg='| lp -d$ptr -og -n$copies' ptr=laser

#	HPLJ-2-postscript testing:

tlj	width=lj t2arg=-Tlj lparg='| %%LIBDIR%%/lj2ps | rlp -d$ptr -n$copies'
tlj	ptr='gate!AppleLaser'

#	Laserjet III (built-in fonts, using supplied widths, Times base)

lj3	width=lj3 t2arg='-Tlj3 -plj3 -W%%FONTDIR%%/lj3'
lj3	lparg='| lp -d$ptr -og -n$copies' ptr=laser
#	Laserjet III (built-in fonts, using supplied widths, Univers base)
lj3u	width=lj3u t2arg='-Tlj3 -plj3u -W%%FONTDIR%%/lj3u'
lj3u	lparg='| lp -d$ptr -og -n$copies' ptr=laser
#	Ditroff:
dlj3	width=lj3 t2arg='-Tlj3 -plj3 -N -W%%FONTDIR%%/lj3'
dlj3	lparg='| lp -d$ptr -og -n$copies' ptr=laser
#	Ditroff:
dlj3u	width=lj3u t2arg='-Tlj3 -plj3u -N -W%%FONTDIR%%/lj3u'
dlj3u	lparg='| lp -d$ptr -og -n$copies' ptr=laser


#	Deskjet: Only difference is troff2ps library inclusions for deskjet.
#	(dt.lib has a slightly different prolog)

dj	width=lj t2arg='-Tlj -pdj' lparg='| lp -d$ptr -og -n$copies' ptr=laser

#	DiTROFF test output (outputs ditroff on screen) using
#	supplied ps widths.

dt	width=ps t2arg='-Tdt -ddjet' lparg="| cat"

#	Ditroff configurations:

#	Tpscript output (ditroff drivers, PS widths, dt libraries)

tp	width=ps t2arg='-Tdt -R720 -dalw'
tp	lparg='| /usr/lib/troff/tpscript | rlp -d$ptr -n$copies'
tp	ptr=gate!AppleLaser

#	jetroff output (ditroff drivers, jt widths, jt libraries)
#	The jt widths are not supplied - see README.  These are widths
#	derived from Knuth's PK fonts from TeX, which are what is distributed
#	with jetroff.  jt.fonts has some example character mapping overrides
#	to make dt.c's mapping tables correspond to jetroff's
#	character->font arrangement.  (Box drawing characters in Rick
#	Richardson's ST (cmtrf) font)

jt	width=jt t2arg='-Tdt -pjt -ddjet' lparg='| djet | lp -d$ptr -n$copies'
jt	ptr=laser

#	X.11 Xtroff using supplied ps width tables
#
#	You should use the same width tables in the width= line
#	as you are printing with.  This way you get xtroff output
#	to agree closely with character placement on the printer.
#	Even if it does look ugly.  A few characters on xtroff don't
#	print as you expect:
#	  ^, @, \(ga, \(em, \(dg, \(bs, \(eq.
#	Some of these may have been fixed in your version of xtroff.
#	Patch 10 is recommended.  If you have an earlier one, define
#	NOCHATTER in defs.h.  Try -Txtfull too and see if it improves things.

xt	width=ps t2arg='-Tdt -dpsc -Z -W%%FONTDIR%%/ps' lparg='| xtroff'
xtfull	width=ps t2arg='-Tdt -dpsc -Z -W%%FONTDIR%%/ps' lparg='| xtroff -full'

#	Adobe Transcript psdit - this appears to work, but I've not
#	set a workable lparg.  A number of characters are missing:
#	@, ^, ff, ffi, ffl (ligatures are off by default anyways),
#	\(bs displays as a heart.

psd	width=ps t2arg='-Tdt -dpsc -Z -W%%FONTDIR%%/ps' lparg='| psdit | something'

#	AT&T ditroff previewer on 3b2's - using supplied ps width tables.
#	Using otroff (CAT troff on these machines) to drive.
#
#	You should probably run xproof's devpsc ditroff width tables
#	through gfttab ("cd widths; gfnttab %%FONTDIR%%/devpsc psc" ?)
#	and change width to psc.  Special note: xproof keeps each symbol
#	character/pointsize in a separate file, and counts as a separate font.
#	The limit appears to be 50 fonts, so testtab.m won't print completely.

troff=otroff
xp	width=ps t2arg='-Tdt -dpsc' lparg='| xproof'
#

troff=''
trofftype='-T$width'

#	Ditroff input driving postscript
dtps	width=alw t2arg='-O0 -Tps -N -W%%FONTDIR%%/ps' ptr='gate!AppleLaser'
dtps	lparg='| $LIBDIR/psxlate -r | rlp -d$ptr -n$copies'

#	Ditroff input driving display postscript (ie: IBM RS/6000)
#	dodps is expecting dpsexec in /usr/local/bin.
#	I run a patched version of dpsexec - the patch I used
#	is in the MISC file.
dps	width=psc t2arg='-O0 -Tps -N -W%%FONTDIR%%/ps -S -Z'
dps	lparg='> /tmp/dps$$ ; %%LIBDIR%%/dodps /tmp/dps$$; rm /tmp/dps$$'
#	LJ3 widths generating postscript
dpslj3	width=lj3 t2arg='-O0 -Tps -N -W%%FONTDIR%%/lj3 -S -Z'

troff=/usr/local/bin/otroff
cdps	v=1 width=ps t2arg='-Tps -S -Z'
cdps	lparg="> /tmp/dps$$; %%LIBDIR%%/dodps /tmp/dps$$; rm /tmp/dps$$'

#	Using groff (gtroff actually) and driving LJ3:
#	You have to copy widths/widthlj3/[A-Z]* to gtroff's
#	width directories/devlj3 for this to work.
troff=gtroff
trofftype='-T$width'
glj3	width=lj3 t2args='-Tlj3 -plj3 -N -Z -O0 -W%%FONTDIR%%/lj3 -G1'
glj3	lparg='lp -og -d$ptr -n$copies' ptr=laser
