.\"Copyright 1988 by Chris Lewis 2.14 91/11/13
.TH TROFF2PS %%MANEXT%% "Psroff %%T2VERSION%%"
.SH NAME
troff2ps, troff2lj, troff2xx \- convert troff output to Postscript, HP etc.
.SH SYNOPSIS
.BI %%LIBDIR%%/troff2 xx
.BI "[\-D" debopts "]"
.BI "[\-T" xx "]"
.BI "[\-R" nn "]"
.BI "[\-P" opt "]*"
.BI "[\-l" length "]"
.BI "[\-p" prolog "]"
.BI "[\-O" l "]"
.BI "[\-Y" l "]"
.BI "[\-W" directory "]"
.B "[\-N]"
.B "[\-Z]"
.B "[\-n]"
.B "[\-V]"
.B "[\-M]"
.B "[\-S]"
.BI "[\-G" ss "]"
.SH DESCRIPTION
.I Troff2ps
takes
CAT
.I troff
output on standard input and transforms it into another format for
output on a printer.
This program is normally invoked by
.IR psroff (%%MANEXT%%),
which has a more complete description of how to use some of the more
interesting features of this program.
.PP
The
.B \-N
option tells troff2ps to expect
.I ditroff
(\f3D\fPevice \f3I\fPndependent \f3Troff\fP)
input instead of CAT
.IR troff .
(NOTE: if you wish to use ditroff, you have to make sure that the
ditroff widths are installed in the proper directory (%%FONTDIR%%/devxxx)
for ditroff to find, and that
.B \-d
option is set correctly to the appropriate name (same as the dev suffix)
so that the ditroff backend will work properly.
.PP
The output format is determined by how
.I troff2ps
is invoked.
Normally,
.I troff2ps
will generate PostScript output, but the
.B \-T
option will allow you to specify other types of output.
Your system administrator (or the original author of this program) may
make other output options available from time to time.
.PP
The
.BI \-l length
option is used to tell the software how long the pages are on the printer.
The default value is 11 inches.
Length should be written as if you were issuing a ``.pl''
.I troff
command; eg: troff scaling should be used.
For example: ``\-l11i'', ``\-l4752u'', ``\-l792p'' and ``\-l66P''
specify a page length of
11 inches in inches,
.I troff
units, points and Picas respectively.
Centimetres (``c'') are also supported, but ``v'', ``m'' and ``n'' are not.
.PP
The
.BI \-T xx
option sets the output format.
For example, "troff2ps \-Tlj" will generate Laserjet output.
.PP
The
.B \-D
option generates scads of diagnostic output in a file called "diagnostics"
in the current directory.
The type of diagnostics is selected by
.IR debopts ,
which is a string of characters from the following list: 'c': cat codes, 's':
special directives, 'f': font management (laserjets), 'b':
cat\(->backend character translations, 'p': PK font handling, 'v':
extremely verbose, 'F' flush after every debug print statement (very slow).
If DEBUG turned off during compilation, this will not be available.
.PP
The
.B \-V
option causes
.I troff2ps
to print a version message and quit.
.PP
A trailer page of statistics can be generated by using the
.B \-M
option provided that the driver supports it.
.PP
Where
.I troff2ps
is generating output for another typesetting filter (eg: jetroff),
sometimes the filter will require different resolution settings for output.
For example, jetroff parsing of ditroff input assumes a resolution of
300 in character positioning, but jetroff does not parse the "x res <nn>"
command.
The
.BI "[\-R" nn "]"
option allows you to specify the resolution that the output filter expects.
Ditroff output has the default resolution set to 300.
(Which is compatible with jetroff.)
.PP
The
.BI \-P opt
directive can be specified as many times as you wish.  It tells
.I troff2ps
to emit each
.I opt
in turn as special requests after the printer-specific
prolog is generated, but before any pages are emitted.
This allows you to specify file inclusions or form overlays or any
other special request feature in a way that won't interfere with
the beginning of documents, or things like changing forms without
modifying the document.
Each
.I opt
is specified in the same way as the
.B sR
macro below.
.PP
The
.B \-O
and
.B \-Y
options allow you to specify page X and Y offsets respectively.
The value should be a number with a valid troff scale factor.
Eg: ``\-O.463i''.
.PP
The
.B \-Z
and
.B \-W
options control the optimizer.
If the
.B \-Z
option is specified, the backends attempt to coalesce strings of
characters into one drawing request.
Without this option,
.B troff2
draws words by positioning each letter separately.
The optimizer can reduce the size of the output file by factors of 3 or
more, and printer speeds similarly, particularly in Postscript.
This option should only be used on printers that scale their fonts,
rather than those that have individual fonts downloaded, unless the
fonts are all precisely scaled.
This is because individual fonts often do not scale very well.
The
.BI \-W directory
allows you to specify where the width tables are.  By default they
are in ``%%FONTDIR%%/\fItype\fP'', where \fItype\fP is the driver
type specified by the
.B \-T
option.
This option is useful if you've moved the width directory somewhere
else, or the final directory name is different from the
.B \-T
value (ie: with ditroff).
See psrofflib entry "ops" for an example.
The
.B \-W
option is ignored unless
.B \-Z
is specified.
.PP
Ditroff output is a special case with respect to optimization.
The optimal form for emitting characters in ditroff is something
like ``\f3c\f2CnnCnnCnnC\f3w\f1'',
``C'' is a character in the word, ``nn'' is the horizontal motion, and ``w'' denotes
the end of a word.
Some ditroff filters will ignore the ``nn'' in ``nnC'' directives, and
will coalesce the characters into strings and rely on the word separator
(``w'') for spacing.
Without optimization, \f3troff2\f2xx\f1's ditroff output does not emit ``w''.
There are two specific ditroff backends where the results are somewhat
suboptimal: xtroff and psdit.
.PP
If
.B \-Z
is specified,
but
.B \-n
is not, ``words'' are emitted as ``\f3c\f2CnnCnnICnnC\f3w\f1''.
This is conformant with ``standard'' ditroff and should work
with any ditroff backend.
If both
.B \-Z
and
.B \-n
are specified, ``words'' are emitted as ``\f3t\f2CCCCC\f1'', which
is accepted by
.B groff 
and
.BR xtroff:
this is a Berkeley ditroff convention.
Setting the
.B \-n
option also implies
.BR \-Z .
.PP
The \-S option indicates that Postscript jobs should be terminated
with the directive "stop" instead of a control-D.
.PP
If you are using \f3groff\fP to drive troff2ps
use the \-Gss option to specify the sizescale value from the groff
DESC files.
.SH "SPECIAL REQUESTS"
.BI troff2 xx
supports a number of additional features over and above bare
CAT
.IR troff .
The macro adapters (see
.IR psroff (%%MANEXT%%))
contain a macro called "\fB.sR\fP".
This macro is used to send special requests to the printer driver.
The macro is invoked with the following arguments:
.RS
.nf
\&.sR "<func><arg><arg>..."
.fi
.RE
.PP
Where
.I func
is a single letter function code.
.I arg
is an argument to the function - the number of arguments a function
takes is dependent on the function.
.TP 1.3i
Function
Meaning
.TP 1.3i
O<name>
Overlay:
use "name" as the name of an overlay file.
More than one can be specified by separating by blanks.
The overlay is typically a name from the printer-specific library.
Eg: "Confidential" is the name for the confidential overlay.
Only supported by postscript driver and this directive must be
executed before any output on the page where the overlay is desired.
A O without a name (eg: ``.sR "O"'') cancels the current overlay.
More than one overlay can be specified in one ``O'' request, as
in "OLetterhead Confidential".
.TP 1.3i
L<name>
Letterhead: same as ``O'', except that the overlay is
cancelled after the first use.
A ``.sR "LLetterhead"'' is the same as a ``.sR "OLetterhead"'' followed
by ``.sR "O"'' after the pagebreak.
Any pre-existing "O" directive is cancelled by the "L" and vice-versa.
.TP 1.3i
FnAA
Switch troff font (n) 1..4 to driver font AA (eg: .fp 1 CW becomes F1CW).
See the
.I *.fonts
files for which fonts are supported.
.TP 1.3i
I<file>
Include the file specified as the single argument into the driver
output.
The driver type is appended onto the end of the file name.
Eg: with the Postscript driver,
".sR Ifoo"
becomes an inclusion of "foo.ps".
.RI troff2 xx
will read the file from the current directory if it exists there, otherwise
from the troff2 library directory.
.sp
These are not
.I troff
inclusions - they are interpreted only by
.RI troff2 xx.
This is how the libraries are loaded.
See the section on libraries on how to write library files.
.sp
For compatibility with psfig, ``f<file>'' is accepted as a synonym.
.TP 1.3i
i<file>
Same as "I", except that no translations are done whatsover,
allowing you to enter binary files in the driver's output stream.
.TP 1.3i
E<string>
Passes "string" through the stderr of the backend.
Used for passing index macro and macro error messages through to where
you can see them.
All drivers.
.TP 1.3i
P<string>
Passes "string" through the backend directly to the printer.
This is how you can send text in troff directly to the printer (ie:
embedded postscript inclusions - eg: psfig).
All drivers.
For compatibility with psfig, ``p<string>'' is accepted as a synonym.
.TP 1.3i
S<string>
Takes the string and executes it as a command.
All drivers.
.TP 1.3i
C<xx>
Where ``xx'' is an extended character from the <type>.fonts file.
Causes psroff to print the character.
The character needs to be defined in a ``extensions'' section in the
appropriate ``fonts'' file for this to work.
.PP
Note: in the macro adapters, the real ``.tm'' directive has been renamed to
``.tM'', and is implemented by invoking ``.sR "E<tm arguments>"''.
Thus, use of ".tm" will simply forward the message through stderr - and
can be used with the common document indexing schemes.
.SH "LIBRARY FILES"
.I Troff2ps
supports the inclusion of printer-specific files both through explicit
inclusions in your
.I troff
files, as well as including a standard prolog in a printer-independent
fashion.
.B troff2ps
always loads the files
.IR xx. lib,
and
.IR xx. fonts,
where
.I xx
is the printer type selected.
Eg: "ps.lib" for PostScript, or "lj.lib" for LaserJet.
.PP
xx.lib contains printer-initialization and xx.fonts contains a list
of fonts and how to select them on the printer.
Precise details of how the fields in xx.fonts is interpreted varies
from device type to device type, and you should consult the
existing .fonts file for the driver you're interested in to see
what can be specified.
.PP
The default prefix is the driver type (eg:
.B \-T
option) but can be overridden by using the
.BI \-p prefix
option.
With an include directive (either "I" or "i" with ".sR"),
.I troff2xx
will append the suffix to the file name before searching for the file.
.PP
Files are searched for in the current directory first, then ./lib
then %%LIBDIR%%/lib last.
.PP
The scanning of normal include files is done by stripping all comments
(prefixed by "%") and all whitespace (in lj driver, not neccessary for
PostScript).
See the comment in the lj.lib file for more details.
Within the lib files you can recursively include other files as well by
using "%%%include filename".
.PP
The "i" include form (.sR macro) or "%%%binclude filename" form (inside
a library file) does the same thing, except that the file included is
simply copied, no translations are done.
.SH "NEW BACKEND MECHANISM FOR SPECIAL DIRECTIVES"
.PP
There is a new mechanism in
.B troff2ps
to support backend communication other than by using ``.sR''.
These commands are invoked by the following sequence:
.RS
.nf
\eka\eo'\e(bs\e(bs'<sequence>\e(bs\eh'|\enau'
.fi
.RE
Which means, mark the current horizontal position in number register ``a'',
overstrike two bell symbols.
<sequence> is any special directive above (eg: Ifilename), where any spaces
are replaced with some non-ASCII character
.RB ( catconv
uses \e(ts).
Then, the sequence is followed by another bell symbol and the horizontal
position is reset to the position marked in ``a''.
Such a directive takes up no horizontal space.
If you want the directive to take up more horizontal space, you have to
add an increment onto the \eh'|\enau' clause.
.BR Catconv ,
for example, converts extended character sets into the above sequence,
where <sequence> is replaced with ``Cxx'', where ``xx'' is the CAT
troff name, and the \eh clause is \eh'|\enau+1n'.
This mechanism isn't perfect - troff2ps's finite state automaton
does get screwed up with moderately complicated PIC directives.
.SH "CHARACTER ENCODING OVERRIDES"
.PP
.B Troff2ps
converts the CAT codes (see cat(1)) into printer codes in the backend drivers
by means of a set of compiled-in tables.
These compiled tables aren't always exactly what you want for your printer.
.B Troff2ps
allows you to override these tables by the use of character overrides in the
.IR xx .fonts
file.
At the end, you can specify what character to print for a given CAT
character.
This is done by the specification of one or more of the ``symbol'', ``normal''
or ``extensions'' sections.
Each section consists of one of these three words, followed by a sequence
of character encoding overrides.
.PP
An override is specified thusly:
.RS
.nf
.ta .5i 1i 2i 3i 4i 5i
char	font	sequence	xshift	yshift	scale
.fi
.RE
.PP
Where ``char'' is the CAT character name, eg: ``a'' for the character
``a'' or ``xx'' for the character ``\e(xx''.
``font'' is ``N'' if the character is to be found in a normal character set,
or ``S'' is the character is to be found in the symbol character set, or a
number specifying that the character should be found in a specific font (the
number starts from 0, and corresponds to the font position in the ``xx.fonts''
file).
Sequence is a string of codes you want to send to the printer for that
character.
Sequence can be any combination of 8 bit characters or 3 digit octal escape
sequences (eg: \e203).
More than one character can be specified, along with backspaces (for
overstriking).
For example, O\e008/ constructs a crude empty-set symbol.
(Backspace sequences or similar things may not work in a given driver.
For example, backspace in Postscript won't do what you want).
xshift and yshift are increments to be added to the X and Y position of the
character before emitting the sequence.
Whitespace (space or tab) cannot occur in the sequence, but you can use
the octal escapes.
These numbers are scaled by the point size and are in the resolution of the
backend driver multiplied by 100.
Similarly, the scale parameter is a factor to apply to the point size, and
is similarly scaled by 100.
.PP
A special font directive ``D'' is also available, which means that the
sequence should be emitted verbatim - this is of use only in Postscript,
where you can use the sequence to be the name of an invokeable function that
draws the desired glyph - the X and Y position will be on the stack.
.PP
font defaults to the same as the header.
sequence defaults to the character name.
xshift, yshift and scale default to 0, 0 and 100 respectively, which means
no x or y shift, and 1:1 scaling.
.PP
As an example to clarify the overall format:
.RS
.nf
normal
a	N
b	S	b
symbol
bs	N	\e341
extensions
AE	4	\e341	0	0	200
.fi
.RE
Which means: character ``a'' is encoded as ``a'' and is found in the normal
font.
Character ``b'' is encoded as ``b'', and is found in the symbol font.
Symbol character \e(bs is to be found in the normal font, and is selected
by emitting the octal character \e341.
And finally,
\e(AE is printed by selecting font 4 (usually the one defined after S
in the xx.fonts file), and scaling by a factor of 2, and emitting \e341
to select it.
.PP
Note: an error will be emitted if you get a troff character name in the
wrong section.
Generally speaking, ``normal'' characters are those that CAT troff has
in fonts other than the symbol font.
Symbol characters are those found in the CAT troff symbol font.
And ``extensions'' are characters that aren't in CAT troff at all, but
can be faked through the ``Cxx'' special directives.
.SH FILES
.if t .ta 2.5i
.if n .ta 3.5i
%%LIBDIR%%	Troff2ps library directory
.br
%%LIBDIR%%/lib/*.fonts	Font tables.
.br
%%LIBDIR%%/lib/*.lib	Prefix libraries for output.
.br
%%FONTDIR%%/*/ft*	Width tables for optimizer
.br
etc.
.SH BUGS
Due to the nature by which special sequences are transmitted by
troff (troff's stderr is merged with its stdout and is piped into
troff2ps's stdin by
.IR psroff ),
normal troff errors will not be seen and may generate a few
"invalid opcode" messages from troff2ps or garble on output.
Normally the document will be truncated if this occurs.
If this happens, run
.I psroff
with the ``\-F'' option which will show you troff's stderr without
generating any output.
.PP
Unfortunately, there is no way at present for the ".sR" macro to
change fonts within a line - for some pretty bizarre reasons if you ask
me.
Never mind.
Ask me if you want more information.
.SH "SEE ALSO"
troff(1), psroff(%%MANEXT%%), catconv(%%MANEXT%%).
.SH AUTHOR
Chris Lewis
