%%STARTSHELL%%
#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#1.5 91/07/20
MAKEDEV=%%MAKEDEV%%
if [ ! -f "$MAKEDEV" ]
then
    echo "no $MAKEDEV program - don't worry unless you're using psroff"
    echo "with REAL ditroff instead of C/A/T troff"
    exit 0
fi
if [ "$1" = "-i" ]
then
    install=1
fi
rm -f DITLIST */ditdone
sed -e '/^[^#].*-N/!d' ../lib/psrofflib > DITLIST
tlist=`sed -e 's/[ 	][ 	]*.*//' DITLIST`
rm -f */ditdone
for i in $tlist
do
    Targ=
    Warg=
    width=
    eval `sed -n -e "/^$i[ 	]/s///p" DITLIST`
    eval "`echo $t2arg | sed -n -e 's/.*-T\([^ 	]*\).*/Targ=\1/p'`"
    eval "`echo $t2arg | sed -n -e 's;.*-W\([^ 	]*\).*;Warg=\1;p'`"
    if [ -n "$Warg" ]
    then
	srcfont=`basename $Warg`
    else
	srcfont=$Targ
    fi
    echo "PROCESSING $i: width=$width, psroff widths: $srcfont"
    if [ -z "$width" ]
    then
	echo "Something wrong with $i entry, skipping (no width)"
	continue
    fi
    dir=width$srcfont
    if [ ! -d $dir ]
    then
	echo "$dir does not exist (for driver $i)"
	continue
    fi
    if [ ! -r $dir/DESC ]
    then
	echo "No DESC file for $dir, skipping"
	continue
    fi
    if [ -z "$install" ]
    then
	if [ -r $dir/ditdone ]
	then
	    continue
	fi
	touch $dir/ditdone
	cd $dir
	find . '(' -name '[A-Z]' -o -name '[A-Z][A-Z]' ')' \
	    -exec $MAKEDEV DESC '{}' ';'
	$MAKEDEV DESC
	cd ..
    else
	destdir=%%FONTDIR%%/dev$width
	if [ ! -d $destdir ]
	then
	    mkdir $destdir
	    echo "Psroff-built width tables" > $destdir/PSROFF-BUILT
	fi
	if [ ! -w $destdir ]
	then
	    echo "Can't create $destdir or can't write in it"
	    continue
	fi
	if [ ! -r $destdir/PSROFF-BUILT ]
	then
	    echo "SKIPPING INSTALL of $dir into $destdir:"
	    echo "  probably pre-existing, won't overwrite"
	    echo "  touch $destdir/PSROFF-BUILT to overwrite anyways"
	    continue
	fi
	cd $dir
	list="`find . -name '*.out' -print`"
	if [ -n "$list" ]
	then
	    echo "INSTALLING ditroff widths from $dir into $destdir"
	    cp $list $destdir
	else
	    echo "No ditroff widths in $dir to install"
	fi
	cd ../
    fi
done
rm -f */ditdone DITLIST
